import sys
from PyQt4 import QtCore, QtGui
from PyQt4.uic.Loader import loader

class own(QtGui.QDialog):

    def __init__(self, *args):
        QtGui.QDialog.__init__(self, *args)
        
        self.threads = []
        snap = QtGui.QTextCursor()
        del snap
        loader.DynamicUILoader().loadUi("form4.ui", self)

        self.connect(self.horizontalSlider, QtCore.SIGNAL("sliderReleased()"), self.modifyThreads)

    def modifyThreads(self):
        cur_threads = len(self.threads)
        threads = self.horizontalSlider.value()
        print "Running: %i   New: %i" % (cur_threads,threads)
        if cur_threads > threads:
            self.stop(cur_threads-threads)
        elif cur_threads < threads:
            self.start(threads-cur_threads)
        
    def start(self,threads):
        for i in range(threads):
            s = myThread(self,i)
            self.threads.append(s)

            s.start()

        self.textLabel1.setText(str(len(self.threads)))
        #self.horizontalSlider.setValue(len(self.threads))

    def stop(self,threads):
        for x in self.threads[-threads:]:
            x.stop()
        for y in range(threads):
            x = self.threads.pop()
            x.wait()

        self.lCDNumber1.display(len(self.threads))  
        self.textLabel1.setText(str(len(self.threads)))     

    @QtCore.pyqtSignature("PyQt_PyObject")
    def write(self, data):
        self.textEdit2.append(data)
    
    @QtCore.pyqtSignature("")
    def on_pushButton3_clicked(self):
        if len(self.threads) > 0:
            s = self.threads.pop()
            s.stop()
            s.wait()
            self.lCDNumber1.display(len(self.threads))  
            self.textLabel1.setText(str(len(self.threads)))     

    @QtCore.pyqtSignature("")
    def on_pushButton5_clicked(self):
        self.pushButton5.setDisabled(True)
        s = myThread(self,len(self.threads))
        self.threads.append(s)
        s.start()
        self.pushButton5.setEnabled(True)
        self.textLabel1.setText(str(len(self.threads)))     

    @QtCore.pyqtSignature("")
    def on_pushButton2_clicked(self):
        self.textEdit2.clear()

    @QtCore.pyqtSignature("")
    def on_pushButton6_clicked(self):
        self.stop(len(self.threads))

class myThread(QtCore.QThread):
    i = 0
    qm = QtCore.QMutex()

    def __init__(self,editor,text):

        QtCore.QThread.__init__(self)
        self.container = editor
        self.text = text
        self.runner = 1

        
    def run(self):

        self.connect(self, QtCore.SIGNAL("steip(PyQt_PyObject)"), self.container,QtCore.SLOT("write(PyQt_PyObject)"),QtCore.Qt.QueuedConnection)
        while self.runner:
            msg = "%i" % (self.text)
            self.emit(QtCore.SIGNAL("steip(PyQt_PyObject)"),msg)
            QtCore.QThread.msleep(100)

    def stop(self):
        self.runner = 0

if __name__ == "__main__":      
    a  = QtGui.QApplication(sys.argv)
    w = own()
    w.start(10)
    w.show()
    w.connect(a, QtCore.SIGNAL("lastWindowClosed()"), w.stop)
    sys.exit(a.exec_())
